###################################################################################################

{ ##  color context
    
    my $gdir;
    my $name_e;
    my ($l,@colors,@sv,@lt,@scl,@ls,$cf,$sp,
	@colors_unsorted,@colors_sorted,%cint1,%cint2,%cint3,
	$cewhere,$fob
);
    my(%cshash,%cuhash);
    @sv = (0,0,0);
    @grad = ();
    foreach( qw(GradBH GradBV GradTH GradTV) ) {
	$STATE{$_} = 10 unless exists $STATE{$_};
    }



########################################################################
# sub label_entry  ripped off from labentlist
# This differs from labentlist in that 
# the variables given are not class Var, but simply perl refs.
# Args:
# $obj
# 'L' or 'E'  (for Label or Entry)
# if 'L' then take text
# if 'E' then take width,value-to-insert
# return $frame, @ents, (frame and entries)
sub label_entry { 
    my($obj,$what,@ents,$one);
    $obj=shift;
    my ($lab,$junk,$file);
    my $f = $obj->Frame(@fracon,);    
    $f->pack(-fill => 'both');
    my @pl = (-side => 'left', -pady => $YPAD1, -anchor => 'w');
    while(@_ != 0 ) {
	$what=shift;
	if($what eq 'L') {
	    $lab = $f->Button(@labcon,-text => shift,-state=>'disabled',
	      -disabledforeground=>'black',-highlightthickness=>'0');
	    $lab->pack(@pl);
	}
	elsif ($what =~ /^File/) {
	    eval "\$lab->bind('<Button-1>' => sub{display_help (\"$what\" ) })";
	    $lab->configure(-state=>'normal',-activebackground=>'green');
	}
	else {
	    my $one = $f->Entry(@entcon,-width => shift);
	    push @ents,$one;
	    $one->pack(@pl);
	    my $var = shift;
	    $one->insert('0',$$var);
	    $one->bind('<Return>'=>sub{$$var=$one->get();});
	}
    }
    return($f,@ents);
}    
########################################################################
sub grad_set {
    $GRADSET->destroy if Exists $GRADSET;
    $GRADSET = $MW->Toplevel;
    my $w = $GRADSET;
    $w->title('Gradient Parameters');
    my $hf = make_help_dismiss($w,'File:gradset');

    my (@w,$junk);
    my $p = 15;
    ($junk,$w[0]) = label_entry($w,'L', pad('Button Horiz.',$p),'E',5,
			\$STATE{GradBH});

    ($junk,$w[1]) = label_entry($w,'L', pad('Button Vert.',$p),'E',5,
				\$STATE{GradBV});

    ($junk,$w[2]) = label_entry($w,'L', pad('Title Horiz.',$p),'E',5,
				\$STATE{GradTH});
    ($junk,$w[3]) = label_entry($w,'L', pad('Title Vert.',$p),'E',5,
				\$STATE{GradTV});

}
######################################################################


sub color_tool {
    
    $COLORTOOL->destroy if Exists($COLORTOOL);
    $COLORTOOL = $MW->Toplevel(@topcon);
    my $w = $COLORTOOL ;
    $w->title('Color Selector');
    my($p1,$p2,$p3,$p4,$p5) = (4,4,5,12,7); # string padding
    make_decor_style_frame($w);
    my $hf = make_help_dismiss($w,'File:color');

    my($width,$height) = ('13','5');
#    my @labcon = (@labcon);
    my @labpack = (-pady => '10');
    my($fl,$fr,$bl,$br) = (0,0,0,0);
    my (@l) ; #label refs
    my($wherechange) = 'bl';
    my @colorlines = `cat $rgbfile`;
    
    my ($sort_flag, @ret,
	$starttext);
    foreach (@colorlines) {
	(@ret) = split;
	if (@ret == 4) {
	    push @colors_unsorted, $ret[3] ;
	    $cint1{$ret[3]} = $ret[0];
	    $cint2{$ret[3]} = $ret[1];
	    $cint3{$ret[3]} = $ret[2];
	}
    }
    @colors_sorted = sort @colors_unsorted;
    my $i=0;
    foreach (@colors_unsorted) {
	$cuhash{$_} = $i++;
    }
    foreach (@colors_sorted) {
	$cshash{$_} = $i++;
    }
    %cint1;%cint2;%cint3;
# believe it or not the above line is neccessary so that these are visible in
# subroutine below.    

    if ($STATE{ColorSort} eq 'Yes') {@colors = @colors_sorted;
			$starttext='unsort'	 }
    else {@colors = @colors_unsorted;$starttext='sort'}

my $nf = $w->Frame(@fracon);
$nf->pack(-side=>'top');
$nf->Label(@labcon,-text=>'Name')->pack(-side=>'left');
 $name_e = $nf->Entry(@entcon,-width=>'25');
$name_e->pack(-side=>'left');
    $nf->Button(@butcon,-text=>'edit',-command=>\&coledit)->pack(-side=>'left');

    my $listheight = 15;
    my $botf = $w->Frame(@fracon);
    my $botfa = $botf->Frame(@fracon);
    $botfa->pack(-side => 'bottom',-expand=>'n',-fill=>'both' );
    $botf->pack(-side => 'bottom' ,-expand=>'n',-fill=>'both');
    my $f = $w->Frame(@fracon, );
    $f->pack(-side => 'left', -expand => 'yes', -fill => 'both');
    my $s = $f->Scrollbar(@scalcon);
    $l = $f->Listbox(@liscon,-yscrollcommand => ['set', $s], -setgrid => 1,
			-width => 20, -height => $listheight);

    $s->configure(-command => ['yview', $l]);
    $s->pack(-side => 'right', -fill => 'y');
    $l->pack(-side => 'left', -expand => 'yes', -fill => 'both');
    $l->insert(0, @colors);
    $l->configure(-width=> max_length(@colors));
    $sb = $hf->Button(@butcon,-text=> $starttext,-command =>
            sub { if ($STATE{ColorSort} eq 'Yes' ){
		  $STATE{ColorSort} = 'No'  ; @colors = @colors_unsorted;
		     $sb->configure(-text=>'sort');
		  } else {
		    $STATE{ColorSort} = 'Yes'  ; @colors = @colors_sorted; 
		       $sb->configure(-text=>'unsort'); 
		  }
		  $l->delete('0','end');    $l->insert(0, @colors);
	      }
    );
    $sb->pack(side=>'right'); 



    my $gf = $hf->Frame(@fracon);
    $gf -> pack(-side=>'right');
# perl-tk 8 doesn't like padx ?
#    $gf -> pack(-side=>'right',-padx=>'4');
    my $gbut = $gf->Button(@labcon,-text=>'Gradient');
     $gbut->pack(-side=>'left');
    bind_help($gbut,'File:gradient');
    my $gfadd = $gf->Button(@butcon,-text=>'Add');
    $gfadd->configure(-command =>
       sub {push @grad,get_color();
	     $gfadd->configure(-background=>'blue');
	     }
    );
    $gfadd->bind('<Button-2>'=>sub{@grad = (); $gfadd->configure(-background=>$butbg)});
    $gfadd->pack(-side=>'left');
    $gdir = $gf->MState('-states' => ['Off','H','V'],@butcon);
    $gdir->pad();
    $gdir->pack(-side=>'left');
    $gdir->bind('<Button-2>'=>\&grad_set);
    my $s1 = $w->Scrollbar(@scalcon);
    my $t1 = $w->Text( @textcon2, -yscrollcommand => ['set', $s1],-height=> 15, -width=> 16);
    $t1->pack(@EF,-side=>'left');
    $s1->configure(-command => ['yview', $t1]);
    $s1->pack(-side => 'right', -fill => 'y');
#    $l->pack(-side => 'left', -expand => 'yes', -fill => 'both');









#    my $f1 = $w->Frame(@fracon,-relief=>'groove',-bd=>'2');
#    $f1->pack(-side => 'left', -expand => 'no', -fill => 'y');  
#    my $f2 = $w->Frame(@fracon,-relief=>'groove',-bd=>'2');
#    $f2->pack(-side => 'left', -expand => 'no', -fill => 'y');  
#my @lpl = (-fill=>'both');
    my @lpl = (-expand=>'yes');
    my ($b1,$b2,$b3,$b4,$b5,$b6,$b7,$b8,$b9,$b10,$b11,$b12,$b13,$b14,$b15,$b16,$b17);
    $b1 =$t1->Button(@butcon,-pady=>'0',-text=> ' Root');
    $b1->bind('<1>' =>  sub {
		       cset('G','RootBackground',"xsetroot -solid '\$color'");
		   }
    );
    bind_history($b1,$CONFIG{Global}{RootBackground});
#    $b1->pack(-side=>'top',-ipady=>'0');
     $t1->window('create', 'end', -window => $b1);
$t1->insert('end',"\n\n");
    $l[0]= $t1->Button(@labcon,-text=>'Border');
#    $l[0] ->pack(-side=>'top',@labpack);
    $t1->window('create', 'end', -window => $l[0]);
$t1->insert('end',"\n");
    $lh[0] = 'File:BorderColor';
   $b2=$t1->Button(@butcon,-pady=>'0',-text=> pad('Fore',$p1));
    $b2->bind('<1>' => 
                   sub {
		     cset('S','ForeColor',"\$color");   
		   }
    );
#    $b2->pack(-side=>'top',-ipady=>'0',@lpl);
     $t1->window('create', 'end', -window => $b2);
$t1->insert('end',"\n");
    bind_history($b2,$CONFIG{Styles}->{$STYLE}->{ForeColor} );

$b3 = $t1->Button(@butcon,-pady=>'0',-text=> pad('Back',$p1));
    $b3->bind('<1>' => 
                   sub {
		       cset('S','BackColor',"\$color");   
		   }
    );

#    $b3->pack(-side=>'top',@lpl);
     $t1->window('create', 'end', -window => $b3);
$t1->insert('end',"\n\n");
     bind_history($b3,$CONFIG{Styles}->{$STYLE}->{BackColor});
       $l[1]= $t1->Button(@labcon,-text=>'Hilight');
#    $l[1]->pack(-side=>'top',@labpack);
    $lh[1] = 'File:HilightColor';
     $t1->window('create', 'end', -window => $l[1]);
$t1->insert('end',"\n");
$b4 = $t1->Button(@butcon,-pady=>'0',-text=> pad('Fore',$p2));
    $b4->bind('<1>' => 
                   sub {
		       cset('D','HilightColorFore',"\$color");   
		   }
    );
#    $b4->pack(-side=>'top',@lpl);
     $t1->window('create', 'end', -window => $b4);
$t1->insert('end',"\n");
     bind_history($b4,$CONFIG{Decors}->{$DECOR}->{HilightColorFore});
    $b5=$t1->Button(@butcon,-pady=>'0',-text=>pad( 'Back',$p2));
    $b5->bind('<1>' => 
                   sub {
		       cset('D','HilightColorBack',"\$color");   
		   }
    );
#    $b5->pack(-side=>'top',@lpl);
     $t1->window('create', 'end', -window => $b5);
$t1->insert('end',"\n\n");
   bind_history($b5,$CONFIG{Decors}->{$DECOR}->{HilightColorBack});
  $l[2]= $t1->Button(@labcon,-text=>'Menus');
#  $l[2] ->pack(-side=>'top',@labpack);
     $t1->window('create', 'end', -window => $l[2]);
$t1->insert('end',"\n");
  $lh[2] = 'File:MenuColor';
    $b6=$t1->Button(@butcon,-pady=>'0',-text=> pad('Fore',$p3));
     $b6->bind('<1>' => 
                   sub {
		       cset('G','MenuFore',"\$color");   
		   }
    );
#    $b6->pack(-side=>'top',@lpl);
     $t1->window('create', 'end', -window => $b6);
$t1->insert('end',"\n");
   bind_history($b6,$CONFIG{Global}->{MenuFore} );

$b7=$t1->Button(@butcon,-pady=>'0',-text=> pad('Back',$p3));
    $b7->bind('<1>' => 
                   sub {
		       cset('G','MenuBack',"\$color");
		       execute_one_global(0,'MenuFore');
		   }
    );
#     $b7->pack(-side=>'top',@lpl);
     $t1->window('create', 'end', -window => $b7);
$t1->insert('end',"\n");
   bind_history($b7,$CONFIG{Global}->{MenuBack} );
    $b8=$t1->Button(@butcon,-pady=>'0',-text=> pad('Shade',$p3));
    $b8->bind('<1>' => 
                   sub {
		       cset('G','MenuShade',"\$color"); 
  		       execute_one_global(0,'MenuFore');
		   }
    );
#    $b8 ->pack(-side=>'top',@lpl);
     $t1->window('create', 'end', -window => $b8);
$t1->insert('end',"\n\n");
   bind_history($b8,$CONFIG{Global}->{MenuShade} );
  $l[3]= $t1->Button(@labcon,-text=>'Title');
#  $l[3] ->pack(-side=>'top',@labpack);
     $t1->window('create', 'end', -window => $l[3]);
$t1->insert('end',"\n");
  $lh[3] = 'File:TitleColor';
   $b9= $t1->Button(@butcon,-pady=>'0',-text=> pad('Active Up',$p4) );
    $b9->bind('<1>' => 
            sub {
		cset('D','TitleActiveUp',"solid \$color");   
	    }
    );
#    $b9 ->pack(-side=>'top',@lpl);
     $t1->window('create', 'end', -window => $b9);
$t1->insert('end',"\n");
   bind_history($b9,$CONFIG{Decors}->{$DECOR}->{TitleActiveUp});
    $b14=$t1->Button(@butcon,-pady=>'0',-text=> pad('Active Down',$p4));
    $b14->bind('<1>' => 
            sub {
		cset('D','TitleActiveDown',"solid \$color");   
	    }
    );
#    $b14->pack(-side=>'top',@lpl);
     $t1->window('create', 'end', -window => $b14);
$t1->insert('end',"\n");
   bind_history($b14,$CONFIG{Decors}->{$DECOR}->{TitleActiveDown});
    $b10=$t1->Button(@butcon,-pady=>'0',-text=> pad('Inactive',$p4));
    $b10->bind('<1>' => 
            sub {
		cset('D','TitleInactive',"solid \$color");   
	    }
    );
#     $b10->pack(-side=>'top',@lpl);
     $t1->window('create', 'end', -window => $b10);
$t1->insert('end',"\n\n");
   bind_history($b10,$CONFIG{Decors}->{$DECOR}->{TitleInactive});
#########################################
  $l[5]= $t1->Button(@labcon,-text=>'Buttons');
     $t1->window('create', 'end', -window => $l[5]);
$t1->insert('end',"\n");
#  $l[5] ->pack(-side=>'top',@labpack);
  $lh[5] = 'File:CSButtons';
   $b15= $t1->Button(@butcon,-pady=>'0',-text=> pad('Active Up',$p4));
    $b15->bind('<1>' => 
            sub {
		cset('B','ActiveUp',"solid \$color");   
	    }
    );
#    $b15 ->pack(-side=>'top',@lpl);
     $t1->window('create', 'end', -window => $b15);
$t1->insert('end',"\n");
   bind_history($b15,button_style_ref()->{ActiveUp});
    $b16=$t1->Button(@butcon,-pady=>'0',-text=> pad('Active Down',$p4));
    $b16->bind('<1>' => 
            sub {
		cset('B','ActiveDown',"solid \$color");   
	    }
    );
#    $b16->pack(-side=>'top',@lpl);
     $t1->window('create', 'end', -window => $b16);
$t1->insert('end',"\n");
   bind_history($b16,button_style_ref()->{ActiveDown});
    $b17=$t1->Button(@butcon,-pady=>'0',-text=> pad('Inactive',$p4));
    $b17->bind('<1>' => 
            sub {
		cset('B','Inactive',"solid \$color");   
	    }
    );
#     $b17->pack(-side=>'top',@lpl);
     $t1->window('create', 'end', -window => $b17);
$t1->insert('end',"\n\n");
   bind_history($b17,button_style_ref()->{Inactive});
###########################################
    $l[4]= $t1->Button(@labcon,-text=>'Pager');
#   $l[4] ->pack(-side=>'top',@labpack);
     $t1->window('create', 'end', -window => $l[4]);
$t1->insert('end',"\n");
  $lh[4] = 'File:PagerColor';
   $b11= $t1->Button(@butcon,-pady=>'0',-text=> pad('Fore',$p5));
    $b11->bind('<1>' => 
                   sub {
		       my $color = get_color();
		       set($CONFIG{Global}->{PagerFore},$color);
		       $STATE{Color}= $color;
		       execute_one_global(0,'PagerOn');
		   }
    );
#    $b11->pack(-side=>'top',@lpl);   
     $t1->window('create', 'end', -window => $b11);
$t1->insert('end',"\n");
   bind_history($b11,$CONFIG{Global}->{PagerFore});
    $b12=$t1->Button(@butcon,-pady=>'0',-text=> pad('Back',$p5));
    $b12->bind('<1>' => 
                   sub {
		       my $color = get_color();
		       set($CONFIG{Global}->{PagerBack},$color);
		       $STATE{Color}= $color;
		       execute_one_global(0,'PagerOn');
		   }
    );
#    $b12 ->pack(-side=>'top',@lpl);   
     $t1->window('create', 'end', -window => $b12);
$t1->insert('end',"\n");

   bind_history($b12,$CONFIG{Global}->{PagerBack});
    $b13=$t1->Button(@butcon,-pady=>'0',-text=> pad('Hilight',$p5));
    $b13->bind('<1>' => 
                   sub {
		       my $color = get_color();
		       set($CONFIG{Global}->{PagerHilight},$color);
		       $STATE{Color}= $color;
		       execute_one_global(0,'PagerOn');
		   }
    );
#   $b13 ->pack(-side=>'top',@lpl);   
     $t1->window('create', 'end', -window => $b13);
$t1->insert('end',"\n");
   bind_history($b13,$CONFIG{Global}->{PagerHilight});
$t1->configure(-state=>'disabled');

    $w->bind('<Page_Down>' => sub { 
	$t1->yview(scroll => 1, 'pages');});
    $w->bind('<Page_Up>' => sub { 
	$t1->yview(scroll => -1, 'pages');});
    $w->bind('<Down>' => sub { 
	$t1->yview(scroll => 1, 'unit');});
    $w->bind('<Up>' => sub { 
	$t1->yview(scroll => -1, 'unit');});


{    my $i;
     for($i=0;$i<@l;$i++) {
	 bind_help($l[$i],$lh[$i]);
	}
}
my $pl =   $botfa->Text(-width=> $width, -height=> $height,-font=>$bfont,-wrap=> 'word');
$pl ->pack(-expand =>'yes',-fill=> 'both',-side=>'left');
my $pr =   $botfa->Text(-width=>$width , -height=>$height,-font=>$bfont ,-wrap=> 'word');
$pr ->pack(-expand =>'yes',-fill=> 'both',-side=>'right');
$pl->insert('0.0','Click and type Sample Text here.');
$pr->insert('0.0','And here too.');

    $botf->Radiobutton(@butcon,-text=>'Fore', 
-variable=>\$wherechange,-value=>'fl',-indicatoron=>'no',
-selectcolor=>'blue') ->pack(-side=>'left');
    $botf->Radiobutton(@butcon,-text=>'Back', 
-variable=>\$wherechange,-value=>'bl',-indicatoron=>'no',
-selectcolor=>'blue') ->pack(-side=>'left');
        $botf->Radiobutton(@butcon,-text=>'Back', 
-variable=>\$wherechange,-value=>'br',-indicatoron=>'no',
-selectcolor=>'blue') ->pack(-side=>'right');
        $botf->Radiobutton(@butcon,-text=>'Fore', 
-variable=>\$wherechange,-value=>'fr',-indicatoron=>'no',
-selectcolor=>'blue') ->pack(-side=>'right');

    $l->bind('<Button-1>' =>
        sub { 
	    my $i = $l->curselection();
	    my $color = $colors[$i];
            $name_e->delete(0,'end');
            $name_e->insert(0,$color);
	    if ($wherechange eq 'fl') {
		$pl->configure(-fg=> $color);$fl=$i; }
	    elsif ($wherechange eq 'bl'){
		$pl->configure(-bg=> $color);$bl=$i; }
	    elsif ($wherechange eq 'fr'){
		$pr->configure(-fg=> $color);$fr=$i; }
	    elsif ($wherechange eq 'br'){
		$pr->configure(-bg=> $color);$br=$i; }
	    if (Exists $COLOREDIT) {
		put_col_edit($color);
	   }

	} );

$pl->bind('<Button-1>' => sub {
    $l->selectionClear('0','end');
    my $i ;
    if ($wherechange eq 'fl') {$i = $fl}
    elsif  ($wherechange eq 'bl'){ $i = $bl}
    else {return}
    $l->selectionSet($i);$l->see($i);
    $name_e->delete(0,'end');
    my $color = $colors[$i];
    $name_e->insert(0,$color);
    if (Exists $COLOREDIT) {
	put_col_edit($color);
    }
    });

$pr->bind('<Button-1>' => sub {
    $l->selectionClear('0','end');
    if ($wherechange eq 'fr') {$i = $fr}
    elsif ($wherechange eq 'br') {$i = $br}
    else {return}
    $l->selectionSet($i);$l->see($i);
    $name_e->delete(0,'end');
    my $color = $colors[$i];
    $name_e->insert(0,$color);
    if (Exists $COLOREDIT) {
	put_col_edit($color);
    }
    });


#foreach ($b1,$b2,$b3,$b4,$b5,$b6,$b7,$b8,$b9,$b10,$b11,$b12,$b13,$b14,$b15,$b16,$b17) {
#    debug 0, join ";",$_->bindtags();
#}




}
# end color_tool
########################################################################

    
sub cset {
    my($type,$name,$inval) = @_;
    my $color = get_color();
    my $val = eval "\"$inval\"";
    if(@grad > 1 and $gdir->get_value() ne 'Off' and ($type eq 'B' or $name =~ /^Title/)) {
	if ($gdir->get_value() eq 'V') {
	    if($type eq 'B') {
		$val = "VGradient $STATE{GradBV} $grad[0] $grad[1]";
	    }
	    else {
		$val = "VGradient $STATE{GradTV} $grad[0] $grad[1]";
	    }
	}
	else {
	    if($type eq 'B') {
		$val = "HGradient $STATE{GradBH} $grad[0] $grad[1]";
	    }
	    else {
		$val = "HGradient $STATE{GradTH} $grad[0] $grad[1]";
	    }
	}
    }
    if ($type eq 'D') { set(decor($name),$val)}
    elsif ($type eq 'S') {set(style($name),$val)}
    elsif ($type eq 'G') {set(global($name),$val)}
    elsif ($type eq 'B'){set(button_style_ref->{$name},$val)}
    $STATE{Color}= $color;
}

#  This creates the color editing tool
sub coledit {
    my $color = get_color();
    $COLOREDIT->destroy if Exists($COLOREDIT);
    $COLOREDIT = $COLORTOOL->Toplevel(@topcon);
    my $w = $COLOREDIT ;
    $w->title('Color Edit');
    my $hf = make_help_dismiss($w,'File:coloredit');
    $sp = $hf->MState(-states => ['RGB','HSB'],@butcon);
#    $sp->pad();
    $sp->pack(-side=>'left',-padx=>'20');
    $STATE{Cspace} = 'RGB' unless exists $STATE{Cspace};
    $sp->value($STATE{Cspace});

    $fob = $hf->MState(-states => ['BackGround','ForeGround'],@butcon);
#    $sp->pad();
    $fob->pack(-side=>'left',-padx=>'20');
    $STATE{FoB} = 'BackGround' ;
#unless exists $STATE{FoB};
    $fob->value($STATE{FoB});




    my $scalelength = '10c';
    @lt = ( ' Red  ', ' Green', ' Blue ');
    $cf = $w->Text(-font => $editorfont,
  -width=>'40',-height=>'8',-relief=>'sunken',-bd=>'2');
    $cf->pack;
    $STATE{CEText} = 'Type here.' unless exists $STATE{CEText};
    $cf->insert('end',$STATE{CEText});
    my $sf = $w->Frame(@fracon);
    $sf-> pack();

    my $i;
    for($i=0;$i<3;$i++) {
       $ls[$i] = $sf->Frame(@fracon);
       $ls[$i]->pack(-side=>'top');
       $scl[$i]= $ls[$i]->Label(@labcon,-textvariable=>\$lt[$i]);
       $scl[$i]->pack(-side=>'left');
       $sc[$i] = $ls[$i]->Scale(@scalcon,
				-from => 0,
				-to       => 255,
				'-length' => $scalelength,
				-orient   => 'horizontal',
				-variable => \$sv[$i],
				-command => \&color_change,
				);
       if ( $STATE{Cspace} eq 'HSB' ) {
	   $sc[$i]->configure(-from => 0,-to=>1000);
	   $lt[0] = ' Hue  '; $lt[1]= ' Sat. ';$lt[2]='Bright';
       }
       $sc[$i]->pack;
   }
   put_col_edit($color);
   $sp->configure(-command => \&sp_bind);
    $fob->configure(-command => \&fob_bind);
}

sub fob_bind {
    my $val = $fob->get_value();
#    debug 0, get_color();
    $STATE{"Old" .$STATE{FoB}} = get_color();
    $STATE{FoB} = $val;
    put_color_on_tool($STATE{"Old$val"}) if exists $STATE{"Old$val"};


}

sub sp_bind {
	my $ispace = $sp->get_value();
	return if $STATE{Cspace} eq $ispace;
	my ($i,@tmp);
	if ($ispace eq 'RGB') {
	    @tmp = hsvToRgb($sv[0]/1000,$sv[1]/1000,$sv[2]/1000);
	    for($i=0;$i<3;$i++) {
		$sv[$i]=$tmp[$i];
	    }
	    foreach(@sc) {
		$_->configure(-from => 0,-to=>255);
	    }
	    $lt[0] = ' Red  '; $lt[1]= ' Green';$lt[2]=' Blue ';
	    $MW->update;
	}
	else {
	    foreach(@sc) {
		$_->configure(-from => 0,-to=>1000);
	    }
	    $MW->update;
	    @tmp = rgbToHsv(@sv);
	    for($i=0;$i<3;$i++) {
		$sv[$i]=int(.5+1000*$tmp[$i]);
	    }
	    $lt[0] = ' Hue  '; $lt[1]= ' Sat. ';$lt[2]='Bright';
	}
	$STATE{Cspace} = $ispace;
    }


sub get_color {
    return $name_e->get;
}
   
sub put_col_edit {
    my $color = shift;
    my ($i,@ints);
    if ( $color =~ /^#/ ) {
	@ints = hex_to_int($color);
    }
    else {@ints = ($cint1{$color},$cint2{$color},$cint3{$color});}
    my $conv = int_to_hex(@ints);
#    debug 0, $STATE{FoB};
    if ($STATE{FoB} eq 'BackGround') {
	$cf->configure(-background => $conv);
    }
    else {
	$cf->configure(-foreground => $conv);
    }
    if ($STATE{Cspace} eq 'RGB' ) {
	for($i=0;$i<3;$i++) {
	    $sv[$i] = $ints[$i];
	}
    }
    else {
	my @ans = rgbToHsv(@ints);
	for($i=0;$i<3;$i++) {
	    $sv[$i] = int(.5+1000*$ans[$i]);
	}
    }
}

sub translate_color {
    my $color = shift;
    my ($nc,$c2);
    $c2 = $color;
    $c2 =~ tr/[A-Z]/[a-z]/;
    foreach (@colors) {
	$nc = $_;
	$nc =~ tr/[A-Z]/[a-z]/;
	return $_ if $nc eq $c2;
    }
    return $color;
}

sub put_color_on_tool {
    my $color = shift;
    my $ind;
    my $tmp ;
    ($tmp) = ($color =~ /solid\s+(.+)/);
#    debug 0, "tmp '$tmp'";
    $color = $tmp if defined $tmp;
    $color =~ s/^\s*(\S+)\s*$/$1/;
    $color =~ s/'//g;
    return unless defined $color;
    $color = translate_color($color);
    $name_e->delete(0,'end');
    $name_e->insert(0,$color);
    if($STATE{ColorSort} eq 'Yes') {
	$ind = $cshash{$color}  if exists $cshash{$color};
    }
    else {
	$ind = $cuhash{$color}  if exists $cuhash{$color};
    }
    $l->selectionClear('0','end');
    $l->selectionSet($ind);$l->see($ind);
    put_col_edit($color) if Exists $COLOREDIT;
}

sub color_change {
    my $conv;
    if ($STATE{Cspace} eq 'RGB' ) {
	$conv = int_to_hex(@sv);
    }
    else {
	my (@ints);
	$conv = int_to_hex(hsvToRgb($sv[0]/1000,$sv[1]/1000,$sv[2]/1000));
    }
#    debug 0, $STATE{FoB};
    if ($STATE{FoB} eq 'BackGround') {
	$cf->configure(-background => $conv);
    }
    else {
	$cf->configure(-foreground => $conv);
    }
    $name_e->delete(0,'end');
    $name_e->insert(0,$conv);
}

sub int_to_hex {
 my @rgb = @_;
 sprintf("#%02x%02x%02x",@rgb);
}

sub hex_to_int {
    my $val = shift;
    my(@ints) = ($val =~ /\#*(..)(..)(..)/ );
    my @out = (hex($ints[0]),hex ($ints[1]),hex( $ints[2]));
    return (@out);
}

# The following two routines were lifted from
#  ColorEditor.pm
#  by Stephen O. Lidie, Lehigh University Computing Center.  95/03/05
#   lusol@Lehigh.EDU
# (changed from 16 bit to 8 bit )

sub hsvToRgb {

    # The procedure below converts an HSB value to RGB.  It takes hue,
    # saturation, and value components (floating-point, 0-1.0) as arguments,
    # and returns a list containing RGB components (integers, 0-65535) as
    # result.  The code here is a copy of the code on page 616 of
    # "Fundamentals of Interactive Computer Graphics" by Foley and Van Dam.

    my($hue, $sat, $value) = @_;
    my($v, $i, $f, $p, $q, $t);
    my $size = 255;

    $v = int($size * $value);
    return ($v, $v, $v) if $sat == 0;
    $hue *= 6;
    $hue = 0 if $hue >= 6;
    $i = int($hue);
    $f = $hue - $i;
    $p = int($size * $value * (1 - $sat));
    $q = int($size * $value * (1 - ($sat * $f)));
    $t = int($size * $value * (1 - ($sat * (1 - $f))));
    return ($v, $t, $p) if $i == 0;
    return ($q, $v, $p) if $i == 1;
    return ($p, $v, $t) if $i == 2;
    return ($p, $q, $v) if $i == 3;
    return ($t, $p, $v) if $i == 4;
    return ($v, $p, $q) if $i == 5;

} # end hsvToRgb

sub rgbToHsv {

    # The procedure below converts an RGB value to HSB.  It takes red, green,
    # and blue components (0-65535) as arguments, and returns a list
    # containing HSB components (floating-point, 0-1) as result.  The code
    # here is a copy of the code on page 615 of "Fundamentals of Interactive
    # Computer Graphics" by Foley and Van Dam.

    my $size = 255;
    my($red, $green, $blue) = @_;
    my($max, $min, $sat, $range, $hue, $rc, $gc, $bc);

    $max = ($red > $green) ? (($blue > $red) ? $blue : $red) :
      (($blue > $green) ? $blue : $green);
    $min = ($red < $green) ? (($blue < $red) ? $blue : $red) :
      (($blue < $green) ? $blue : $green);
    $range = $max - $min;
    if ($max == 0) {
        $sat = 0;
    } else {
        $sat = $range / $max;
    }
    if ($sat == 0) {
        $hue = 0;
    } else {
        $rc = ($max - $red) / $range;
        $gc = ($max - $green) / $range;
        $bc = ($max - $blue) / $range;
        $hue = ($max == $red)?(0.166667*($bc - $gc)):
          (($max == $green)?(0.166667*(2 + $rc - $bc)):
           (0.166667*(4 + $gc - $rc)));
    }
    return ($hue, $sat, $max/$size);

} # end rgbToHsv

} # end color context


1;


