
#############################################################################################
# begin global routines context

{  
    my (@pl,$key,$scalelength,$junk);
    my $g = $CONFIG{Global};
my ($e1,$e2);

    my @vars =
	qw(  EdgeScrollx  EdgeScrolly EdgeTime EdgePixels ClickTime
	 OpaqueMoveSize  ClickFocusRaise MouseFocusRaise
	 ClickPasses ColorMapFocus SmartPlacementSmart
	 MenuFont MenuFore MenuBack MenuShade  MenuStyle
	 );

#######################################################
sub initialize_global_panel {
    foreach (@vars){$g->{$_}->initialize_panel}
}
###########################################################################
sub put_global_values_on_panel {
    foreach (@vars){$g->{$_}->put_value_on_panel;}
}

#############################################################################
sub get_global_values_from_panel {
    foreach (@vars) {$g->{$_}->get_value_from_panel;
#		     debug 0, "getting $_: ";
    }
}
###################################################################

#############################################################################################
sub set_global { 
    $SETGLOBAL->destroy if Exists($SETGLOBAL); 
    $SETGLOBAL = $MW->Toplevel(@topcon);
    my $w = $SETGLOBAL ;
    my $tf = make_help_dismiss($w,"NoHelp");
    $w->title('Global Options');
    my $p = 28; #padding
    $scalelength = '10c';
#    foreach(@vars) { 
#	$g->{$_}->set_panel_toplevel($w)}
    initialize_global_panel ();
#    put_global_values_on_panel ();

    my $apply = $tf->Button(
			   @butcon,
			   -text => 'Apply',
			    -activebackground=> $applybg,
			   -command => sub{
                               get_global_values_from_panel();
			       set_unsaved();
			       execute_global(0);
#			   recapture();
			   });
     $apply->pack(-side => 'right', );

 @pl = (-side => 'left', -anchor => 'w');


($junk,$e1) = labentlist($w,
			    'L', 'Root','File:root',
			     'E', '35' ,$g->{RootBackground},
			 );

$g->{RootBackground}->put_panel_ref($e1);




my $f3 = $w->Frame(@fracon,);
$f3->pack(-fill => 'x');
my $lf3 = $f3->Button(@labcon,-text => 'EdgeScroll x  ');
$lf3->pack(-side=>'left', -anchor =>'e');
bind_help($lf3,"File:edgescroll");
my $sc1 = $f3->Scale(@scalcon,
            -from     => 0,
            -to       => 100,
            '-length' => $scalelength,
            -orient   => 'horizontal',
	    -variable => $g->{EdgeScrollx}->get_panel_ref()
        );
$sc1->pack(@pl);
my $f4 = $w->Frame(@fracon,);
$f4->pack(-fill => 'x');
my $lf4=$f4->Button(@labcon,-text => 'EdgeScroll y  ');
$lf4->pack(-side=>'left', -anchor =>'e');
bind_help($lf4,"File:edgescroll");
my $sc2 = $f4->Scale(@scalcon,
            -from     => 0,
            -to       => 100,
            '-length' => $scalelength,
            -orient   => 'horizontal',
	    -variable => $g->{EdgeScrolly}->get_panel_ref
        );
$sc2->pack(@pl);
my $f7 = $w->Frame(@fracon,);
$f7->pack(-fill => 'x');
my $lf7 = $f7->Button(@labcon,-text => 'OpaqueMoveSize');
$lf7 ->pack(-side=>'left', -anchor =>'e');
bind_help($lf7,"File:opaque");
my $sc3 = $f7->Scale(@scalcon,
            -from     => 0,
            -to       => 100,
            '-length' => $scalelength,
            -orient   => 'horizontal',
	    -variable => $g->{OpaqueMoveSize}->get_panel_ref,
        );
$sc3->pack(@pl);


($junk,$e1,$e2) = labentlist($w,
			    'L', pad('EdgeResistance: Time',$p), 'File:edgeresistance',
			     'E', '4' ,$g->{EdgeTime},
			    'L', '  Pixels',
			   'E', '4' ,$g->{EdgePixels},
);

$g->{EdgeTime}->put_panel_ref($e1);
$g->{EdgePixels}->put_panel_ref($e2);




($junk,$e1) = labentlist($w,
		       'L',pad('ClickTime',$p),
		       'E',6,$g->{ClickTime}, );
$g->{ClickTime}->put_panel_ref($e1);

radlablist($w,pad('Click to Focus Passes Click ',$p),
	   $g->{ClickPasses}->get_panel_ref,
    'Yes','ClickToFocusPassesClick',
    'No','ClickToFocusDoesntPassClick'
    );

radlablist($w,pad('Extra-Smart Placement',$p),
	   $g->{SmartPlacementSmart}->get_panel_ref,
    'Yes','SmartPlacementIsReallySmart',
    'No','SmartPlacementIsNormal'
    );

radlablist($w,pad('Raise on Click to Focus',$p),
	   $g->{ClickFocusRaise}->get_panel_ref,
    'Yes','ClickToFocusRaises',
    'No','ClickToFocusDoesntRaise'
    );

radlablist($w,pad('Mouse Focus Click Raises',$p),
	   $g->{MouseFocusRaise}->get_panel_ref,
    'Yes','MouseFocusClickRaises',
    'No','MouseFocusClickDoesntRaise'
    );

radlablist($w,pad('Colormap Focus Follows ...',$p), 
	   $g->{ColorMapFocus}->get_panel_ref,
    'Mouse','ColorMapFocusFollowsMouse',
    'Focus','ColorMapFocusFollowsFocus'
    );

my $p1 = 11;
($junk,$e1) = labentlist($w,
		       'L',pad('Icon Font',$p1),
		       'E',34,$g->{IconFont}, );
$g->{IconFont}->put_panel_ref($e1);

my $f1 = $w->Frame(@fracon);
$f1->pack(-expand=>'y', -fill =>'both');
$f1->Label(@labcont,-text=>'   Menus   ')->pack;


($junk,$e1) = labentlist($w,
			    'L', pad('Font',$p1),
			     'E', '34' ,$g->{MenuFont},
);
$g->{MenuFont}->put_panel_ref($e1);


($junk,$e1) = labentlist($w,
			    'L', pad('Fore Color',$p1),
			     'E', '34' ,$g->{MenuFore},
);
$g->{MenuFore}->put_panel_ref($e1);

($junk,$e1) = labentlist($w,
			    'L', pad('Back Color',$p1),
			     'E', '34' ,$g->{MenuBack},
);
$g->{MenuBack}->put_panel_ref($e1);

($junk,$e1) = labentlist($w,
			    'L', pad('Shade Color',$p1),
			     'E', '34' ,$g->{MenuShade},
);
$g->{MenuShade}->put_panel_ref($e1);

radlablist($w,pad('Mwm Style',$p1), 
	   $g->{MenuStyle}->get_panel_ref,
    'Yes','mwm',
    'No','fvwm'
    );

}

# end set_global();

}
# end global routines context
