{ # font context
    local (@av_fonts, @save_fonts); 
    local $list;

######################################################################
sub set_font_select_font {
    my $font = shift;

   send_command   "\nAddToDecor FontSelect WindowFont $font";
}

sub set_fonts {

#my $font = $MW->Font(
#		    space   => 'p', 
#                     weight  => 'medium',
#                     point   => 140
#);

my $titlestring = "AaBbCcDdEeFf";
set_font_select_font '7x14';
send_command	"Style \"$titlestring\" UseDecor FontSelect";

#my @av_fonts = sort $font->Name(10000);
my @in_fonts = sort `xlsfonts`;
my %hash;
foreach (@in_fonts) { $hash{$_}++};
@av_fonts = sort keys %hash;
 @save_fonts = @av_fonts;
my $maxwidth = 0;
my ($l,$selfont,$where);

foreach $name (@av_fonts) {
    $l = length $name;
    $maxwidth = $l if $l > $maxwidth;
}

$selfont =  $av_fonts[1];
$where = 'none';

$SETFONTS->destroy if Exists($SETFONTS);
$SETFONTS = $MW->Toplevel((@topcon));
my $w = $SETFONTS ;
$w->title($titlestring);
make_decor_style_frame($w);
my $nframe = $w->Frame(@fracon,);
$nframe->pack(-side => 'top');
my $hf= make_help_dismiss($w,'File:fonts');
#$w->title("Font Selector: Fvwm");
#my $tframe = $w->Frame(@fracon);
#$tframe->pack(-side => 'top', -fill => 'x');

my $b1 = $hf->Radiobutton(@radcon,-text => 'Window', -variable => \$where, -value => 'WindowFont');
my $b2 = $hf->Radiobutton(@radcon,-text => 'Icon', -variable => \$where, -value => 'IconFont');
my $b3 = $hf->Radiobutton(@radcon,-text => 'Menu', -variable => \$where, -value => 'MenuFont');
my $b4 = $hf->Radiobutton(@radcon,-text => 'Just Look', -variable => \$where, -value => 'none');
@pl = (-side => 'right', -pady => $YPAD1, -anchor => 'e' ,-expand => 'yes');
$b1->pack(@pl);
$b2->pack(@pl);
$b3->pack(@pl);
$b4->pack(@pl);
bind_history($b1,decor('WindowFont'));
bind_history($b2,global('IconFont'));
bind_history($b3,global('MenuFont'));
my $fb=$hf->Button(@butcon2,-text=>'filt',-command=>\&font_filter);
$fb->pack(-side=>'left');
my $fvb = $hf->Button(@butcon2,-text=>'fvwmconf',-command=>\&fvwmconf_fonts);
$fvb->pack(-side=>'left');



my $ent=$nframe->Entry(@entcon,-width => '30');
$ent->insert(0,"ABCDabcdEFGHIefghi");
$ent->pack();


my $w_frame = $w->Frame(@fracon, );
$w_frame->pack(-side => 'top', -expand => 'yes', -fill => 'both');
my $w_frame_scroll = $w_frame->Scrollbar(@scalcon);
$list = $w_frame->Listbox(@liscon,-yscrollcommand => ['set', $w_frame_scroll], -setgrid => 1,
				     -width => $maxwidth, -height => $fontlistheight);
$w_frame_scroll->configure(-command => ['yview', $list]);
$w_frame_scroll->pack(-side => 'right', -fill => 'y');
$list->pack(-side => 'left', -expand => 'yes', -fill => 'both');
$list->insert(0,sort @av_fonts);

$setsub = sub {
    my $i = $list->curselection();
    $selfont = $av_fonts[$i];
    chomp $selfont;
    $ent->configure(-font => $selfont);
    set_font_select_font $selfont;

    if ($where eq 'MenuFont') {
	$CONFIG{Global}->{MenuFont}->set_value($selfont);
	$CONFIG{Global}->{MenuFont}->put_value_on_panel();
	execute_one_global(0,'MenuFore');
	set_unsaved();
    }
    elsif ($where eq 'none' ) {;}
    elsif ($where eq 'WindowFont') {
	$CONFIG{Decors}->{$DECOR}->{WindowFont}->set_value($selfont);
	set_unsaved();
	execute_decor($DECOR,0);
	$CONFIG{Decors}->{$DECOR}->{WindowFont}->put_value_on_panel();
    }
    elsif ($where eq 'IconFont') {
	$CONFIG{Global}->{IconFont}->set_value($selfont);
	$CONFIG{Global}->{IconFont}->put_value_on_panel();
	execute_one_global(0,'IconFont');
	set_unsaved();
    }

};

$w->bind('<Down>' => 
                 sub { 
		     my $i = $list->curselection();
		     if ($i < $#av_fonts) {
			 $list->selectionClear($i);
			 $list->selectionSet($i+1);
			 $list->see($i+1);
			 &$setsub;
		     }
		 });
$w->bind('<Up>' => 
                 sub { 
		     my $i = $list->curselection();
		     if ($i > 0)  {
			 $list->selectionClear($i);
			 $list->selectionSet($i-1);
			 $list->see($i-1);
			 &$setsub;
		     }
		 });

my $filter;

    
$list->bind('<Button-1>' => $setsub);


}
# end set_fonts

sub font_filter {
    my $list = $list;
    my $save = \@save_fonts;
    my $av = \@av_fonts;

    $FONTFILTER->destroy if Exists($FONTFILTER);
    $FONTFILTER = $SETFONTS->Toplevel((@topcon));
    my $w = $FONTFILTER ;
    $w->title('Font Filter');
    my $hf= make_help_dismiss($w,'File:fontfilter');
    my $f = $w->Frame(@fracon);
    $f->pack;
    $f->Label(@labcon,-text=>'Include')->pack(-side=>'left');
    my $ei=$f->Entry(@entcon,-width=>'20');
    $ei->pack(-side=>'left');
    $ei->bind('<Return>' => sub {
	my $words = $ei->get();
#    	debug 0,join (";",@$save);
#	debug 0,join (";",@$av);
	if ($words eq '' or $words =~ /^\s+$/) {
	    @$av = @$save;
	}
        else {	@$av = grep /$words/ ,@$save;}
	$list->delete(0,'end');
	$list->insert(0,@$av);
    });
}

# This is ugly, had problems getting it to work.  Should be cleaned quite a bit
sub fvwmconf_fonts {
    $FVWMCONFFONTS->destroy if Exists($FVWMCONFFONTS);
    $FVWMCONFFONTS = $SETFONTS->Toplevel((@topcon));
    my $w = $FVWMCONFFONTS ;
    $w->title('Fvwmconf Fonts');    
    my @fn = ('Button', 'Button 2', 'Help Button', 'Menu', 'Help Text','Editor Text','Small');
    my @fl = ('bfont','bfont2','hbfont','mfont','hfont','editorfont','small_font');
    my @k = qw(ButtonFont ButtonFont2  HelpButtonFont MenuFont HelpFont EditorFont SmallFont );
    my $hf= make_help_dismiss($w,'File:fvwmconffonts');
    my $f = $w->Frame(@fracon);
    $f->pack(@EF);
    my $i;
    for ($i=0;$i<@fn;$i++) {
	my $t = $fn[$i];
	my $v = $fl[$i];
	my $k = $k[$i];
	$f->Button(@butcon,-text=>pad($t,20), -command => 
		   sub {
		       my $j = $list->curselection();
		       $selfont = $av_fonts[$j];
		       chomp $selfont;    
		       eval "\$$v = '$selfont'";
		       setcons();
		       eval "\$STATE{$k} = \$$v";
#		       debug 0, "\$$v = '$selfont'";
##		       debug(0,join ":","hi",@fl);
#		       debug 0, "$selfont";
#		       foreach (@butcon) {
#			   debug 0 ,"$_";
#		       }
		   }
       )->pack();}

}





} # end font context

1;





